=== debian/changelog ===
deepin-system-monitor (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 31 May 2017 15:23:52 +0800
